@echo off
cls
rem     BTSECT   version 2.5   Freeware from TweakHomePC.
rem     For Advanced users.
rem     Creates a new Bootsect.dos on C:\.
rem     Optionally, first creates a new Win9x/Me boot sector (using Sys.com).
rem
rem     (c) LarryM 2002-2003     thpc@mail.com
rem     http://tweakhomepc.virtualave.net/thpc.html
rem
if "%1"=="/?" goto USAGE
if "%1"=="/h" edit /r btsect.txt
if "%1"=="/help" edit /r btsect.txt
if "%1"=="help" edit /r btsect.txt
if not "%winbootdir%"=="" goto USAGE
if not exist c:\nul goto NOCDRV
echo.
echo    Just a moment please . . .
set PATHY=%PATH%
set SYSCMD=
set PTH=
set CCLR=
if not "%RAMD%"=="" set PATH=%RAMD%:\;a:\
if "%RAMD%"=="" set COMSPEC=a:\command.com
set PTH=A
if not "%RAMD%"=="" set PTH=%RAMD%
if not exist %PTH%:\attrib.exe goto MISSING
if not exist a:\command.com goto MISSING
If not exist a:\choice.com goto MISSING
if not exist %PTH%:\debug.exe goto MISSING
if not exist %PTH%:\sys.com goto MISSING
if not exist a:\bootread.scr goto MISSING
if "%1"=="THPC" goto STRT1
cls
echo.
echo.
echo    BTSECT:   (Advanced users)
echo.
echo    The Bootsect.DOS file contains the Win9x/Me boot sector (C:)
echo    in a dual-boot of Win9x/Me and a Win XP/2000/NT.
echo.
echo    BTSECT.BAT creates a NEW Bootsect.DOS from the C: boot sector.
echo    C: must be a valid Win9x/Me boot sector, or one must be created here.
echo    If it boots to the Win9x then it's likely to be a valid Win9x boot sector
echo    (and you do not need to use the SYS option - see below).
echo.
echo    Functions:
echo     1. All bootfiles in C:\ are saved (to c:\BOOTSBCK\9x & ...\NT).
echo     2. An existing C:\Bootsect.DOS is renamed C:\Bootsect.PRV
echo     3. [Option] Create a NEW Win9x boot sector on C: using SYS command.
echo     4. [Option, if SYS was run] Saved Win9x bootfiles are restored to C:\.
echo     5. BOOTSECT.DOS IS CREATED (an image of current boot sector of C:).
echo.
echo    # XP/2000/NT will boot when Fixboot is run (from Recovery Console).
echo.
echo    Use Btsect at your own risk.
echo.
echo.
choice " >> READ THE HELP FILE (Btsect.TXT) "
if errorlevel 2 goto STRT0
if exist a:\btsect.txt edit /R a:\btsect.txt
:STRT0
cls
echo.
if not exist a:\btsect.txt echo    Could not locate the readme file!
echo.
choice " >> CREATE A NEW BOOTSECT.DOS NOW "
if errorlevel 255 goto USAGE
if errorlevel 2 goto HLP
if errorlevel 1 goto STRT1
goto USAGE
:STRT1
cls
echo.
echo    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
echo.
echo    All system bootfiles on C:\ will be backed up first . . .
if not exist c:\bootsbck\nul goto SAVEBTS
echo.
echo    A backup ALREADY EXISTS.
echo.
choice " * REPLACE BACKUP "
if errorlevel 2 goto NOBTS
:SAVEBTS
if not exist c:\bootsbck\nul md c:\bootsbck
if not exist c:\bootsbck\NT\nul md c:\bootsbck\NT
if not exist c:\bootsbck\9x\nul md c:\bootsbck\9x
echo.
echo    Backing up XP/2000/NT bootfiles to C:\BOOTSBCK\NT
if exist c:\arcldr.exe attrib -r -s -h c:\arcldr.exe
if exist c:\arcsetup.exe attrib -r -s -h c:\arcsetup.exe
if exist c:\boot.ini attrib -r -s -h c:\boot.ini
if exist c:\bootsect.* attrib -r -s -h c:\bootsect.*
if exist c:\ntbootdd.sys attrib -r -s -h c:\ntbootdd.sys
if exist c:\ntdetect.com attrib -r -s -h c:\ntdetect.com
if exist c:\ntldr attrib -r -s -h c:\ntldr
if exist c:\arcldr.exe copy /y /v c:\arcldr.exe c:\bootsbck\NT > nul
if exist c:\arcsetup.exe copy /y /v c:\arcsetup.exe c:\bootsbck\NT > nul
if exist c:\boot.ini copy /y /v c:\boot.ini  c:\bootsbck\NT > nul
if exist c:\bootsect.dos copy /y /v c:\bootsect.dos c:\bootsbck\NT > nul
if exist c:\ntbootdd.sys copy /y /v c:\ntbootdd.sys c:\bootsbck\NT > nul
if exist c:\ntdetect.com copy /y /v c:\ntdetect.com c:\bootsbck\NT > nul
if exist c:\ntldr copy /y /v c:\ntldr c:\bootsbck\NT > nul
if exist c:\boot.ini attrib +r +s +h c:\boot.ini
if exist c:\bootsect.dos attrib +r +s +h c:\bootsect.dos
if exist c:\bootsect.prv attrib +r c:\bootsect.prv
echo.
echo    Backing up Win9x bootfiles to C:\BOOTSBCK\9x
if exist c:\command.com attrib -r -s -h c:\command.com
if exist c:\drvspace.bin attrib -r -s -h c:\drvspace.bin 
if exist c:\io.sys attrib -r -s -h c:\io.sys
if exist c:\msdos.sys attrib -r -s -h c:\msdos.sys
if exist c:\command.com copy /y /v c:\command.com c:\bootsbck\9x > nul
if exist c:\drvspace.bin copy /y /v c:\drvspace.bin c:\bootsbck\9x > nul
if exist c:\io.sys copy /y /v c:\io.sys c:\bootsbck\9x > nul
if exist c:\msdos.sys copy /y /v c:\msdos.sys c:\bootsbck\9x > nul
echo  Btsect.bat (from Btsect25.zip) first backed up these bootfiles (except Bootsect.NEW).>c:\bootsbck\read.txt
:NOBTS
if "%1"=="THPC" goto HLP
if not exist c:\bootsect.dos goto DOIT
echo    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
echo.
echo    Bootsect.DOS has been found on C:\
attrib -r -s -h c:\bootsect.dos
if exist c:\bootsect.prv attrib -r -s -h c:\bootsect.prv
if not exist c:\bootsect.prv goto SKP3
echo.
echo    Deleting a previous BACKUP of Bootsect.dos . . .
del c:\bootsect.prv > nul
:SKP3
ren c:\bootsect.dos bootsect.prv > nul
attrib +r c:\bootsect.prv
echo.
echo    C:\Bootsect.dos has been renamed  C:\Bootsect.PRV
:DOIT
echo.
echo    * Press any key to Continue . . .
pause > nul
cls
echo.
echo.
echo    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ver
echo    SYS C:
echo    -----
echo.
echo    The SYS C: command should be used ONLY IF the Win9x does not boot.
echo.
echo    The SYS C: command WRITES a NEW Win9x boot sector to the C: drive
echo    (it also copies Win9x bootfiles to root of C:\).
echo.
echo    IT OVERWRITES THE CURRENT BOOT SECTOR.
echo.
echo    The version of Windows that made this bootdisk is shown above.
echo    It should match the version of Win9x installed (but read Btsect.TXT).
echo.
echo    Press [N] key if in any doubt. SYS is strictly for Advanced users!
echo.
echo    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
echo.
set SYSCMD=NOO
choice " > USE THE SYS C: COMMAND "
if errorlevel 2 goto PG
set SYSCMD=YES
:PG
if %SYSCMD%==NOO goto BTSCT
echo    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
echo.
echo    Creating a NEW BOOT SECTOR . . .
echo.
SYS C:
echo.
echo    Done.
echo The SYS C: command created a NEW Win9x boot sector on C:.>>c:\bootsbck\read.txt
echo.
echo    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
echo.
echo    The saved Win9x system bootfiles can be restored to C:\
echo.
echo    This is optional. However . . . YOU MUST PRESS [Y]
echo    if using an INCORRECT VERSION of bootdisk or Startup Disk.
echo.
choice " > RESTORE ORIGINAL SYSTEM BOOTFILES "
if errorlevel 2 goto BTSCT
echo.
echo    Original Win9x system bootfiles are being restored . . .
if exist c:\command.com attrib -r -s -h c:\command.com
if exist c:\drvspace.bin attrib -r -s -h c:\drvspace.bin 
if exist c:\io.sys attrib -r -s -h c:\io.sys
if exist c:\msdos.sys attrib -r -s -h c:\msdos.sys
if exist c:\bootsbck\9x\*.* copy /v c:\bootsbck\9x\*.* c:\
:BTSCT
cls
echo.
echo.
echo    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
echo.
echo    CREATING BOOTSECT.DOS NOW . . .
echo.
DEBUG <BOOTREAD.SCR > NUL
if not exist c:\bootsect.dos goto FAILD
copy /y /v c:\bootsect.dos c:\bootsbck\NT\bootsect.new > nul
attrib +r +s +h c:\bootsect.dos
if exist c:\io.sys attrib +r +s +h c:\io.sys
if exist c:\msdos.sys attrib +r +s +h c:\msdos.sys
echo Btsect.bat then created a new C:\BOOTSECT.DOS (and backed it up as ...\NT\Bootsect.NEW).>>c:\bootsbck\read.txt
echo    Done.
echo.
echo    BOOTSECT.DOS WAS CREATED ON C:
echo    with file attributes of Read-only, Hidden, System (+r +h +s).
echo.
echo    The new Bootsect.dos was copied to c:\bootsbck\NT\Bootsect.NEW
if exist c:\bootsect.prv echo    The old Bootsect.dos was renamed Bootsect.PRV
echo    All bootfiles were saved to c:\BOOTSBCK\
echo    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
echo.
echo    FINISHED!
echo.
echo    When a correct Bootsect.DOS is successfully created:
echo    1. Win9x boots normally.
echo    2. To enable a Win XP/2000/NT boot (and dual-boot),
echo       - boot from its CD, press R (and C for 2K) to run Recovery Console,
echo       - type FIXBOOT, and then BOOTCFG /REBUILD
echo       (NT users: boot Setup Disks, and select "Inspect Boot Sector").
echo.
choice " * READ DUAL-BOOT REPAIR HELP  "
if errorlevel 2 goto END
if errorlevel 1 goto HLP
goto END
:HLP
cls
echo.
echo.
echo    REPAIR HELP    (typical XP/2000/NT + Win9x/Me dual-boot)
echo.
echo    ACTIVE BOOT drive (C:) must be a FAT or FAT32 file system for Win9x.
echo    BOOTSECT.DOS (Win9x boot sector image) must be on root of C:\
echo    Creating Bootsect.dos requires C: to be a Windows 9x boot sector.
echo    SYS C: creates new Win9x boot sector (& overwrites existing sector).
echo.
echo    XP/2000/NT can be repaired using its installation CD or Setup Disks.
echo    BOOT SECTOR of active drive (C:) in dual-boot must be for XP/2000/NT.
echo    FIXBOOT creates XP/2K/NT boot sector (boot CD, run Recovery Console).
echo    BOOTCFG /REBUILD rebuilds Boot.ini (boot CD, run Recovery Console).
echo    BOOT.INI [operating systems] must contain a line like   C:\="Windows 9x"
echo    NTLDR & NTDETECT.COM can be copied from  \i386\  folder on the CD.
echo.
echo    BOOTFILES: All must be on active drive (C:). Attributes often +r +s +h.
echo    XP/2000/NT - Boot.ini, Bootsect.dos, Ntdetect.com, Ntldr, (Ntbootdd.sys)
echo      (also Arcldr.exe and Arcsetup.exe for Win 2000).
echo    WIN9X/Me   - Command.com, Io.sys, Msdos.sys, (Drvspace.bin).
echo.
echo.
choice " * Exiting now.  FINISHED READING  "
if errorlevel 2 goto HLP
goto END
:FAILD
cls
echo.
echo.
echo    W_A_R_N_I_N_G
echo.
echo    Failed to create a new BOOTSECT.DOS
echo.
if not exists c:\bootsect.prv goto SKP4
attrib -r -s -h c:\bootsect.prv
ren c:\bootsect.prv bootsect.dos > nul
attrib +r +s +h c:\bootsect.dos
echo     The Bootsect.DOS on C:\ has not been altered.
:SKP4
if exist c:\io.sys attrib +r +s +h c:\io.sys
if exist c:\msdos.sys attrib +r +s +h c:\msdos.sys
echo.
echo.
choice " * PRESS [Y] or [N] KEY TO FINISH "
if errorlevel 2 goto HLP
if errorlevel 1 goto HLP
goto END
:NOCDRV
cls
echo.
echo.
echo    CAN NOT ACCESS THE C: DRIVE.
echo.
echo    You should consider using
echo    SYS C:
echo    from the bootdisk made by the installed Win9x/Me.
echo.
choice " * Exiting now. FINISHED READING  "
if errorlevel 2 goto NOCDRV
if errorlevel 1 edit /r btsect.txt
goto END
:MISSING
cls
set CCLR=NOO
echo.
echo.
echo    ATTENTION:
echo.
echo    ------------------------------------------
echo.
set TXT= is not on the bootdisk.
if not exist %PTH%:\attrib.exe echo    ATTRIB.EXE (15KB) %TXT%
if not exist a:\command.com echo    COMMAND.COM (91-92KB) %TXT%
if not exist a:\choice.com echo    CHOICE.COM (6KB) %TXT%
if not exist %PTH%:\debug.exe echo    DEBUG.EXE (21KB) %TXT%
if not exist %PTH%:\sys.com echo    SYS.COM (19KB) %TXT%
if not exist a:\bootread.scr echo    BOOTREAD.SCR (1KB) from Bootsect25.ZIP is not on the floppy.
echo.
echo    ------------------------------------------
set TXT=
echo.
echo    You must copy the missing file(s) to the bootdisk from the
echo    \COMMAND\ folder in Win9x, or from the correct Win9x CD.
echo.
echo    Then run BTSECT.BAT again.
echo.
echo    Example:
echo    COPY C:\WINDOWS\COMMAND\CHOICE.COM A:\
echo.
goto END
:USAGE
echo.
echo.
echo    USAGE: BTSECT.BAT
echo.
echo    Creates the Windows 9x/Me boot sector file
echo    C:\BOOTSECT.DOS
echo    with file attributes of +r +h +s.
echo.
echo    Optionally uses SYS C: to create a new Win9x/Me boot sector before
echo    creating the Bootsect.dos file.
echo.
echo    Bootsect.dos is required by Win XP/2000/NT to dual-boot Win9x/Me.
echo.
echo    Runs only in true MS-DOS. No switches are used.
echo.
echo.
echo  * Press any key to Exit.
pause > nul
goto HLP
:END
set PATH=%PATHY%
set SYSCMD=
set PTH=
@echo off
if not "%CCLR%"=="NOO" cls
set CCLR=
EXIT
